/**************************************************************************************************|
|* Copyright 2022 Hycon Technology, Corp.                                                         *|
|* http://www.hycontek.com/                                                                       *|
|* Description:                                                                                   *|
|* - Generic Peripheral Library: A general and functional Interface for the specific Peripheral   *|
|* - Low Level Peripheral Access: Register-Bits Level access Macro, user must take care           *|
|*   of calling procedure and hardware constraints                                                *|
|* - Support Target: HY17M Series                                                                 *|
|**************************************************************************************************/

/**************************************************************************************************|
|*                               Peripheral Register Bits field                                   *|
|**************************************************************************************************/
////	BIEARH		//
//#define	ENBIE		7
//#define	ENBIE_MSK				(1<<ENBIE)
//#define	ENBIE_DISABLE		    (0<<ENBIE)
//#define	ENBIE_ENABLE			(1<<ENBIE)

////	EECR1		//
#define EEMODE                       6
#define EEMODE_MSK                  (3 << EEMODE)
//#define EEMODE_Rev                (3 << EEMODE)
//#define EEMODE_Rev                (2 << EEMODE)
#define EEMODE_64bytes              (1 << EEMODE)
#define EEMODE_32bytes              (0 << EEMODE)

#define	EEWR		0
#define	EEWR_MSK			(1<<EEWR)
#define	EEWR_NORMAL		(0<<EEWR)
#define	EEWR_WRITE			(1<<EEWR)

/**************************************************************************************************|
|*                                      Function Level                                            *|
|**************************************************************************************************/
/*-------------------------------------------------------------------------------------------------|
|  Function-like Macro:                                                                            |
|    Register Bits field Configuration without function call overhead,                             |
|    user should take care of detail of h/w behavior and constrains.                               |
|-------------------------------------------------------------------------------------------------*/
#define BIE_EEPModeSel(EEPSel)     (EECR1 = ((EECR1 & (~EEMODE_MSK)) | EEPSel))
#define	BIE_EEPNormal()		       (EECR1 &= (~EEWR_MSK))
#define BIE_EEPWrite()             (EECR1 |= EEWR_WRITE)
#define	BIE_EEPReload()		       (EECR2 = 0xa5)




/*-------------------------------------------------------------------------------------------------|
|  Function call:                                                                                  |
|    For general and functional register access.                                                   |
|-------------------------------------------------------------------------------------------------*/
void BIE_EEPMode(unsigned char eemode);
void BIE_DataReload(void);
void BIE_DataWrite(void);

	