/**************************************************************************************************|
|* Copyright 2022 Hycon Technology, Corp.                                                         *|
|* http://www.hycontek.com/                                                                       *|
|* Description:                                                                                   *|
|*                                                                                                *|
|**************************************************************************************************/

/**************************************************************************************************|
|*  Includes                                                                                      *|
|**************************************************************************************************/
#include <hy17m28sfr.h>
#include <LED.h>
/**************************************************************************************************|
|*  Static Function                                                                               *|
|**************************************************************************************************/

/**************************************************************************************************|
|*  Generic Peripheral Library                                                                    *|
|**************************************************************************************************/
/*----------------------------------------------------------------------------------------------------------------------------------------------------|
|  Function: LEDSetting                                                                      			     				   											|
|                                                                                                 																					|
|  Parameters:                                                                                                                                                         		     |	
|         cclevel         - [in]	CCLevel_2mA / CCLevel_3mA / CCLevel_5mA / CCLevel_7mA / CCLevel_9mA	              |
|                                        CCLevel_11mA / CCLevel_13mA / CCLevel_15mA
|  Returns:                                                                               		                                                                                  |
|         None               		                   		                   		                   		                   		                   		                       |
|                                                                                       		                   		                   		                                        |
|  Description:                                                                                																					 |
|         This function is used to open LED Driver                                               														       |
|-------------------------------------------------------------------------------------------------------------------------------------------------------*/
void LEDSetting(unsigned char cclevel)
{
	CCNT_CCLevelSel(cclevel);
	ENCCALL_Enable();
	PT2DA=0x00;

}

/*----------------------------------------------------------------------------------------------------------------------------------------------------|
|  Function: GetDisplay                                                                                                                               |
|                                                                                                                                              	  	  |
|  Parameters:                                                                                                                                        |	
|         show         - [in]	LED show data                                                                                                         |
|         ledx           - [in]   LED show ledx                                                                                                       |
|  Returns:                                                                               	                                             	          |
|         None               		                   	                     		                                                                  |
|                                                                                       	                                             	          |
|  Description:                                                                                                                             	  	  |
|         This function is used to get LEDx show data                                                                                                 |
|-----------------------------------------------------------------------------------------------------------------------------------------------------*/
unsigned char GetDisplay(unsigned char show,unsigned char ledx)
{
unsigned char RRTemp,RLTemp,RRR;
	RRTemp=show;
	RLTemp=show;

	RRR=0xff;

	RRTemp=(RRTemp<<1);
	RRR=(RRR<<ledx);
	RRTemp &= RRR;

	RRR=0xff;
	RRR=RRR>>(8-ledx);
	RLTemp &= RRR;
	RRR= RLTemp | RRTemp;

	return RRR;
}